//---------------------------------------------------------------
//   Bulls and cows.  C 1998 Crazy Hedgehog SoftWare  /10.01.98 //
//---------------------------------------------------------------
#define APPNAME "Bulls"
#include <string.h>
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <iostream.h>
#include <io.h>
#include <commdlg.h>
#include "bulls.h"
//---------------------------------------------------------------
#if defined (WIN32)
   #define IS_WIN32 TRUE
#else
   #define IS_WIN32 FALSE
#endif
#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95 (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32
//---------------------------------------------------------------
HINSTANCE hInst;      // current instance
char szAppName[100];  // Name of the app
char szTitle[100];    // The title bar text
int int_str_length=4, int_str_pos=0, int_num_len, int_man=0, int_mem;
int int_i, int_j, int_bulls, int_cows;
char str2[9], str[9], str_comp_num[9],str_input[9], ch_symb;
HWND wnd;
//---------------------------------------------------------------
ATOM MyRegisterClass(CONST WNDCLASS*);
BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK News(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK Setup(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK SPY(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK WINNER(HWND, UINT, WPARAM, LPARAM);
BOOL CenterWindow (HWND, HWND);
LPTSTR   GetStringRes (int id);
//---------------------------------------------------------------
//  FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)
//---------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
   MSG msg;
   HANDLE hAccelTable;
   lstrcpy (szAppName, APPNAME);
   LoadString (hInstance, IDS_APP_TITLE, szTitle, 100);
   if (!hPrevInstance) {
      if (!InitApplication(hInstance)) {
         return (FALSE);
      }
   }
   if (!InitInstance(hInstance, nCmdShow)) {
      return (FALSE);
   }

   hAccelTable = LoadAccelerators (hInstance, szAppName);

   while (GetMessage(&msg, NULL, 0, 0)) {
      if (!TranslateAccelerator (msg.hwnd, hAccelTable, &msg)) {
         TranslateMessage(&msg);
         DispatchMessage(&msg);
      }
   }

   return (msg.wParam);

   lpCmdLine;
}
//---------------------------------------------------------------
//  FUNCTION: MyRegisterClass(CONST WNDCLASS*)
//---------------------------------------------------------------
ATOM MyRegisterClass(CONST WNDCLASS *lpwc)
{
   HANDLE  hMod;
   FARPROC proc;
   WNDCLASSEX wcex;
   hMod = GetModuleHandle ("USER32");
   if (hMod != NULL) {
#if defined (UNICODE)
      proc = GetProcAddress (hMod, "RegisterClassExW");
#else
      proc = GetProcAddress (hMod, "RegisterClassExA");
#endif
      if (proc != NULL) {
         wcex.style         = lpwc->style;
         wcex.lpfnWndProc   = lpwc->lpfnWndProc;
         wcex.cbClsExtra    = lpwc->cbClsExtra;
         wcex.cbWndExtra    = lpwc->cbWndExtra;
         wcex.hInstance     = lpwc->hInstance;
         wcex.hIcon         = lpwc->hIcon;
         wcex.hCursor       = lpwc->hCursor;
         wcex.hbrBackground = lpwc->hbrBackground;
                     wcex.lpszMenuName  = lpwc->lpszMenuName;
         wcex.lpszClassName = lpwc->lpszClassName;
         wcex.cbSize = sizeof(WNDCLASSEX);
         wcex.hIconSm = LoadIcon(wcex.hInstance, "SMALL");
         return (*proc)(&wcex);//return RegisterClassEx(&wcex);
      }
   }
   return (RegisterClass(lpwc));
}
//---------------------------------------------------------------
//  FUNCTION: InitApplication(HANDLE)
//---------------------------------------------------------------
BOOL InitApplication(HINSTANCE hInstance)
{
    WNDCLASS  wc;
    HWND      hwnd;
    hwnd = FindWindow (szAppName, NULL);
    if (hwnd) {
        if (IsIconic(hwnd)) {
            ShowWindow(hwnd, SW_RESTORE);
        }
        SetForegroundWindow (hwnd);
        return FALSE;
        }
        wc.style         = CS_HREDRAW | CS_VREDRAW;
        wc.lpfnWndProc   = (WNDPROC)WndProc;
        wc.cbClsExtra    = 0;
        wc.cbWndExtra    = 0;
        wc.hInstance     = hInstance;
        wc.hIcon         = LoadIcon (hInstance, "BULLS");
        wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
        wc.lpszMenuName  = "WIN95";
        wc.lpszClassName = szAppName;
        if (IS_WIN95) {
   return MyRegisterClass(&wc);
        } else {
   return RegisterClass(&wc);
        }
}
//---------------------------------------------------------------
//   FUNCTION: InitInstance(HANDLE, int)
//---------------------------------------------------------------
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
   hInst = hInstance;
   hWnd = CreateWindow(szAppName, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
      NULL, NULL, hInstance, NULL);
   if (!hWnd) {
      return (FALSE);
   }
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   return (TRUE);
}
//---------------------------------------------------------------
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//---------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   POINT pnt;
   HMENU hMenu;
   switch (message) {
      case WM_CREATE:
      SetWindowPos (hWnd, NULL, CW_USEDEFAULT+100, 100, CW_USEDEFAULT, 100, SWP_NOSIZE | SWP_NOZORDER);
       DialogBox(hInst, "MainBox", hWnd, (DLGPROC)News);
       DestroyWindow (hWnd);
      case WM_NCRBUTTONUP: // RightClick on windows non-client area...
         if (IS_WIN95 && SendMessage(hWnd, WM_NCHITTEST, 0, lParam) == HTSYSMENU)
         {
            return (DefWindowProc(hWnd, message, wParam, lParam));
         } else {
            return (DefWindowProc(hWnd, message, wParam, lParam));
         }
            break;
        case WM_RBUTTONDOWN: // RightClick in windows client area...
            pnt.x = LOWORD(lParam);
            pnt.y = HIWORD(lParam);
            ClientToScreen(hWnd, (LPPOINT) &pnt);
            hMenu = GetSubMenu (GetMenu (hWnd), 2);
            if (hMenu) {
                TrackPopupMenu (hMenu, 0, pnt.x, pnt.y, 0, hWnd, NULL);
            } else
            { // Couldn't find the menu...
                MessageBeep(0);
            }
            break;
      case WM_DESTROY:
         PostQuitMessage(0);
         break;
      default:
         return (DefWindowProc(hWnd, message, wParam, lParam));
   }
   return (0);
}
//---------------------------------------------------------------
//  FUNCTION: About(HWND, unsigned, WORD, LONG)
//---------------------------------------------------------------
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
   static  HFONT hfontDlg;    // Font for dialog text
   static   HFONT hFinePrint; // Font for 'fine print' in dialog
   DWORD   dwVerInfoSize;     // Size of version information block
   LPSTR   lpVersion;         // String pointer to 'version' text
   DWORD   dwVerHnd=0;        // An 'ignored' parameter, always '0'
   UINT    uVersionLen;
   WORD    wRootLen;
   BOOL    bRetCode;
   int     i;
   char    szFullPath[256];
   char    szResult[256];
   char    szGetName[256];
   DWORD dwVersion;
   char  szVersion[40];
   DWORD dwResult;
   switch (message) {
        case WM_INITDIALOG:
         ShowWindow (hDlg, SW_HIDE);
            hfontDlg = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                  VARIABLE_PITCH | FF_SWISS, "");
            hFinePrint = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                    VARIABLE_PITCH | FF_SWISS, "");
         CenterWindow (hDlg, GetWindow (hDlg, GW_OWNER));
         GetModuleFileName (hInst, szFullPath, sizeof(szFullPath));
         dwVerInfoSize = GetFileVersionInfoSize(szFullPath, &dwVerHnd);
         if (dwVerInfoSize) {
            LPSTR   lpstrVffInfo;
            HANDLE  hMem;
            hMem = GlobalAlloc(GMEM_MOVEABLE, dwVerInfoSize);
            lpstrVffInfo  = GlobalLock(hMem);
            GetFileVersionInfo(szFullPath, dwVerHnd, dwVerInfoSize, lpstrVffInfo);
            lstrcpy(szGetName, GetStringRes(IDS_VER_INFO_LANG));
            wRootLen = lstrlen(szGetName); // Save this position
            lstrcat (szGetName, " ");
            bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
               (LPSTR)szGetName,
               (LPVOID)&lpVersion,
               (UINT *)&uVersionLen);
            for (i = DLG_VERFIRST; i <= DLG_VERLAST; i++) {
               GetDlgItemText(hDlg, i, szResult, sizeof(szResult));
               szGetName[wRootLen] = (char)0;
               lstrcat (szGetName, szResult);
               uVersionLen   = 0;
               lpVersion     = NULL;
               bRetCode      =  VerQueryValue((LPVOID)lpstrVffInfo,
                  (LPSTR)szGetName,
                  (LPVOID)&lpVersion,
                  (UINT *)&uVersionLen);
               if ( bRetCode && uVersionLen && lpVersion) {
                  lstrcpy(szResult, lpVersion);
                  SetDlgItemText(hDlg, i, szResult);
               }
              else
               {
                  dwResult = GetLastError();
                  wsprintf(szResult, GetStringRes(IDS_VERSION_ERROR), dwResult);
                  SetDlgItemText (hDlg, i, szResult);
               }
               SendMessage (GetDlgItem (hDlg, i), WM_SETFONT,
                  (UINT)((i==DLG_VERLAST)?hFinePrint:hfontDlg),
                  TRUE);
            } // for (i = DLG_VERFIRST; i <= DLG_VERLAST; i++)
            GlobalUnlock(hMem);
            GlobalFree(hMem);
         } else {
         } // if (dwVerInfoSize)
            SendMessage (GetDlgItem (hDlg, IDC_LABEL), WM_SETFONT,
            (WPARAM)hfontDlg,(LPARAM)TRUE);
         dwVersion = GetVersion();
         if (dwVersion < 0x80000000) {
            wsprintf (szVersion, "Microsoft Windows NT %u.%u (Build: %u)",
               (DWORD)(LOBYTE(LOWORD(dwVersion))),
               (DWORD)(HIBYTE(LOWORD(dwVersion))),
                    (DWORD)(HIWORD(dwVersion)) );
         } else if (LOBYTE(LOWORD(dwVersion))<4) { // Win32s
                wsprintf (szVersion, "Microsoft Win32s %u.%u (Build: %u)",
               (DWORD)(LOBYTE(LOWORD(dwVersion))),
               (DWORD)(HIBYTE(LOWORD(dwVersion))),
                    (DWORD)(HIWORD(dwVersion) & ~0x8000) );
         } else { // Windows 95
                wsprintf (szVersion, "Microsoft Windows 95 %u.%u",
                    (DWORD)(LOBYTE(LOWORD(dwVersion))),
                    (DWORD)(HIBYTE(LOWORD(dwVersion))) );
         }
          SetWindowText (GetDlgItem(hDlg, IDC_OSVERSION), szVersion);
         ShowWindow (hDlg, SW_SHOW);
         return (TRUE);
      case WM_COMMAND:
         if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) {
            EndDialog(hDlg, TRUE);
            DeleteObject (hfontDlg);
            DeleteObject (hFinePrint);
            return (TRUE);
         }
         break;
   }
    return FALSE;
}
//---------------------------------------------------------------
//   Game window
//---------------------------------------------------------------
LRESULT CALLBACK News(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{   BOOL bGotHelp ;
    PAINTSTRUCT ps;
    HDC hdc;
   static  HFONT hfontDlg;    // Font for dialog text
   static  HFONT hFinePrint; // Font for 'fine print' in dialog
   int     i;
   char    szResult[256];
   wnd=hDlg;
   switch (message) {
        case WM_INITDIALOG:
        srand( (unsigned)time( NULL ) );
        l_0_ong_rand(int_str_length);
         ShowWindow (hDlg, SW_HIDE);
            hfontDlg = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                  VARIABLE_PITCH | FF_SWISS, "");
            hFinePrint = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                    VARIABLE_PITCH | FF_SWISS, "");
         CenterWindow (hDlg, GetWindow (hDlg, GW_OWNER));
            for (i = DLG_VERFIRST; i <= DLG_VERLAST; i++) {
               GetDlgItemText(hDlg, i, szResult, sizeof(szResult));
               SendMessage (GetDlgItem (hDlg, i), WM_SETFONT,
                  (UINT)((i==DLG_VERLAST)?hFinePrint:hfontDlg),
                  TRUE);}
            SendMessage (GetDlgItem (hDlg, IDC_LABEL), WM_SETFONT,
            (WPARAM)hfontDlg,(LPARAM)TRUE);
           ShowWindow (hDlg, SW_SHOW);
           _itoa(int_str_length,str,10); //setup info
           SendDlgItemMessage(hDlg,IDC_LIST8, LB_INSERTSTRING,-1, str);
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDBS), FALSE) ;
           for (int_i=0;int_i<=9;int_i++) str_input[int_i]=32;
          return (TRUE);
          case WM_COMMAND:
           switch (LOWORD(wParam)){
           case IDC_LIST1:
            int_mem=SendDlgItemMessage(hDlg,IDC_LIST1, LB_GETCURSEL,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST3,LB_SETCURSEL,int_mem,0);
            SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,int_mem,0);
            break;
           case IDC_LIST2:
            int_mem=SendDlgItemMessage(hDlg,IDC_LIST2, LB_GETCURSEL,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST1,LB_SETCURSEL,int_mem,0);
            SendDlgItemMessage(hDlg,IDC_LIST3,LB_SETCURSEL,int_mem,0);
            break;
           break;
           case IDC_LIST3:
            int_mem=SendDlgItemMessage(hDlg,IDC_LIST3, LB_GETCURSEL,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST1,LB_SETCURSEL,int_mem,0);
            SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,int_mem,0);
            break;
           break;
           case IDCANCEL:
            EndDialog(hDlg, TRUE);
            DeleteObject (hfontDlg);
            DeleteObject (hFinePrint);
            return (TRUE);
            break;
           case IDEMPTY:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           // If you sure to right - delete next string
           DialogBox(hInst, "SPY", hDlg, (DLGPROC)SPY);
           break;
           case ID0:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=0+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID0), FALSE) ;
            break;
            };
            break;
           case ID1:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
           if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=1+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID1), FALSE) ;
            break;
            };
            break;
           case ID2:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
           if (int_str_pos+1==int_str_length)
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=2+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID2), FALSE) ;
            break;
            };
            break;
           case ID3:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=3+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID3), FALSE) ;
            break;
            };
            break;
           case ID4:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=4+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID4), FALSE) ;
            break;
            };
            break;
           case ID5:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=5+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID5), FALSE) ;
            break;
            };
            break;
           case ID6:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=6+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID6), FALSE) ;
            break;
            };
            break;
           case ID7:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=7+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID7), FALSE) ;
            break;
            };
            break;
           case ID8:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=8+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID8), FALSE) ;
            break;
            };
            break;
           case ID9:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           if (int_str_pos+1==int_str_length)
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE);
           SetFocus(GetDlgItem(hDlg, IDENTER)) ;
           }
           else
           {
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;
           };
            if (int_str_pos==int_str_length)
            {
            EnableWindow(GetDlgItem(hDlg, IDENTER), TRUE) ;
            break;
            ;}
            else
            {
            int_str_pos=int_str_pos+1;
            str_input[int_str_pos]=9+48;
            EnableWindow(GetDlgItem(hDlg, IDBS), TRUE) ;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1, str_input);
            EnableWindow(GetDlgItem(hDlg, ID9), FALSE) ;
            break;
            };
            break;
           case IDBS:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            if (int_str_pos>0)
            {
            ch_symb=str_input[int_str_pos];
            str_input[int_str_pos]=32;
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_INSERTSTRING,-1,str_input);
            int_str_pos=int_str_pos-1;
            int_i=(unsigned int)ch_symb;
            int_i=int_i-48;
            switch (int_i)
             {
             case 0:{ EnableWindow(GetDlgItem(hDlg, ID0), TRUE);break;};
             case 1:{ EnableWindow(GetDlgItem(hDlg, ID1), TRUE);break;};
             case 2:{ EnableWindow(GetDlgItem(hDlg, ID2), TRUE);break;};
             case 3:{ EnableWindow(GetDlgItem(hDlg, ID3), TRUE);break;};
             case 4:{ EnableWindow(GetDlgItem(hDlg, ID4), TRUE);break;};
             case 5:{ EnableWindow(GetDlgItem(hDlg, ID5), TRUE);break;};
             case 6:{ EnableWindow(GetDlgItem(hDlg, ID6), TRUE);break;};
             case 7:{ EnableWindow(GetDlgItem(hDlg, ID7), TRUE);break;};
             case 8:{ EnableWindow(GetDlgItem(hDlg, ID8), TRUE);break;};
             case 9:{ EnableWindow(GetDlgItem(hDlg, ID9), TRUE);break;};
             }
            EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE) ;  //off
            ;}
            if (int_str_pos==0)
            {
            EnableWindow(GetDlgItem(hDlg, IDBS), FALSE);
            };
            break;
           case IDENTER:
           SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
           SendDlgItemMessage(hDlg,IDC_LIST1,LB_INSERTSTRING,-1,str_input);
           EnableWindow(GetDlgItem(hDlg, ID0), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, IDBS), FALSE);
           EnableWindow(GetDlgItem(hDlg, ID1), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID2), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID3), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID4), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID5), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID6), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID7), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID8), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID9), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE)  ;
           int_man++;  //peopl turns
           int_bulls=0;
           int_cows=0;
           for (int_i=0;int_i<=int_str_pos;int_i++)
           {
            if (str_comp_num[int_i-1]==str_input[int_i]) int_bulls++;
            };
           _itoa(int_bulls,str2,10);
           SendDlgItemMessage(hDlg,IDC_LIST3,LB_INSERTSTRING,-1,str2);
           int_i=0;
           while (int_i<=int_str_pos)  //cows
            {
            int_j=0;
            while (int_j<=int_str_pos)
             {
             if ((str_comp_num[int_j-1]==str_input[int_i]) & (int_i!=int_j)) int_cows++;
             int_j++;
             };
            int_i++;
            };
           _itoa(int_cows,str2,10);
           for (int_i=0;int_i<=9;int_i++) str_input[int_i]=32;
           SendDlgItemMessage(hDlg,IDC_LIST2,LB_INSERTSTRING,-1,str2);
           SetFocus(GetDlgItem(hDlg, IDC_LIST1)) ;
           SendDlgItemMessage(hDlg,IDC_LIST1,LB_SETCURSEL,int_man-1,0);
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
           int_str_pos=0;
           if (int_bulls==int_str_length)
           {
             EnableWindow(GetDlgItem(hDlg, ID0), FALSE);
             EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE);
             EnableWindow(GetDlgItem(hDlg, IDBS), FALSE) ;
             EnableWindow(GetDlgItem(hDlg, ID1), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID2), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID3), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID4), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID5), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID6), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID7), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID8), FALSE);
             EnableWindow(GetDlgItem(hDlg, ID9), FALSE);
             DialogBox(hInst, "WINNER", hDlg, (DLGPROC)WINNER);
           };
           break;
           case IDM_ABOUT:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            DialogBox(hInst, "AboutBox", hDlg, (DLGPROC)About);
            break;
           case IDM_NEW:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            l_0_ong_rand(int_str_length);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            for (int_i=0;int_i<int_man;int_i++)
            {
            SendDlgItemMessage(hDlg,IDC_LIST1, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST2, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST3, LB_DELETESTRING,0,0);
            };
            for (int_i=0;int_i<=9;int_i++) str_input[int_i]=32;
            int_str_pos=0;
             EnableWindow(GetDlgItem(hDlg, ID0), TRUE);
             EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE);
             EnableWindow(GetDlgItem(hDlg, IDBS), FALSE) ;
             EnableWindow(GetDlgItem(hDlg, ID1), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID2), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID3), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID4), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID5), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID6), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID7), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID8), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID9), TRUE);
             int_man=0;
            break;
           case IDNEW:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            l_0_ong_rand(int_str_length);
            SendDlgItemMessage(hDlg,IDC_LIST7, LB_DELETESTRING,0,0);
            for (int_i=0;int_i<int_man;int_i++)
            {
            SendDlgItemMessage(hDlg,IDC_LIST1, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST2, LB_DELETESTRING,0,0);
            SendDlgItemMessage(hDlg,IDC_LIST3, LB_DELETESTRING,0,0);
            };
            for (int_i=0;int_i<=9;int_i++) str_input[int_i]=32;
            int_str_pos=0;
             EnableWindow(GetDlgItem(hDlg, ID0), TRUE);
             EnableWindow(GetDlgItem(hDlg, IDENTER), FALSE);
             EnableWindow(GetDlgItem(hDlg, IDBS), FALSE) ;
             EnableWindow(GetDlgItem(hDlg, ID1), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID2), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID3), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID4), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID5), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID6), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID7), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID8), TRUE);
             EnableWindow(GetDlgItem(hDlg, ID9), TRUE);
             int_man=0;
            break;
           case IDM_SETUP:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            DialogBox(hInst, "SETUP", hDlg, (DLGPROC)Setup);
            break;
           case IDSETUP:
           SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            DialogBox(hInst, "SETUP", hDlg, (DLGPROC)Setup);
            break;
           case IDM_EXIT:
            DestroyWindow (hDlg);
            break;
          case IDM_MY_HELP:
          SetFocus(GetDlgItem(hDlg, IDEMPTY)) ;
            bGotHelp = WinHelp (hDlg, APPNAME".HLP",HELP_CONTENTS,(DWORD)NULL);
             if (!bGotHelp)
               {
                  MessageBox (GetFocus(), GetStringRes(IDS_NO_HELP),
                              szAppName, MB_OK|MB_ICONHAND);
               }
            break;
         }
         break;
         case WM_DISPLAYCHANGE: // Only comes through on plug'n'play systems
      {
         SIZE  szScreen;
         DWORD dwBitsPerPixel = (DWORD)wParam;
         szScreen.cx = LOWORD(lParam);
         szScreen.cy = HIWORD(lParam);
         MessageBox (GetFocus(), GetStringRes(IDS_DISPLAYCHANGED),
                     szAppName, 0);
      }
      break;
      case WM_PAINT:
         hdc = BeginPaint (hDlg, &ps);
         EndPaint (hDlg, &ps);
         break;
   }
    return FALSE;
}
LRESULT CALLBACK Setup(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{   PAINTSTRUCT ps;
    HDC hdc;
   static  HFONT hfontDlg;    // Font for dialog text
   static  HFONT hFinePrint; // Font for 'fine print' in dialog
   int     i;
   char    szResult[256];
   switch (message) {
        case WM_INITDIALOG:
         ShowWindow (hDlg, SW_HIDE);
            hfontDlg = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                  VARIABLE_PITCH | FF_SWISS, "");
            hFinePrint = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                    VARIABLE_PITCH | FF_SWISS, "");
         CenterWindow (hDlg, GetWindow (hDlg, GW_OWNER));

            for (i = DLG_VERFIRST; i <= DLG_VERLAST; i++) {
               GetDlgItemText(hDlg, i, szResult, sizeof(szResult));
               SendMessage (GetDlgItem (hDlg, i), WM_SETFONT,
                  (UINT)((i==DLG_VERLAST)?hFinePrint:hfontDlg),
                  TRUE);}
            SendMessage (GetDlgItem (hDlg, IDC_LABEL), WM_SETFONT,
            (WPARAM)hfontDlg,(LPARAM)TRUE);
           ShowWindow (hDlg, SW_SHOW);
           EnableWindow(GetDlgItem(hDlg, IDOK), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), FALSE) ;
           SetFocus(GetDlgItem(hDlg, ID04)) ;
         return (TRUE);
          case WM_COMMAND:
           switch (LOWORD(wParam)){
           case IDCANCEL:
            EndDialog(hDlg, TRUE);
            DeleteObject (hfontDlg);
            DeleteObject (hFinePrint);
            return (TRUE);
            break;
           case ID02:
           int_num_len=2;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "2");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID03:
           int_num_len=3;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "3");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID04:
           int_num_len=4;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "4");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID05:
           int_num_len=5;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "5");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID06:
           int_num_len=6;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "6");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID07:
           int_num_len=7;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "7");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID08:
           int_num_len=8;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "8");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE)  ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID09:
           int_num_len=9;
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_INSERTSTRING,-1, "9");
           EnableWindow(GetDlgItem(hDlg, ID10), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), TRUE) ;
           SetFocus(GetDlgItem(hDlg, IDOK)) ;
           break;
           case ID_BS_SET:
           EnableWindow(GetDlgItem(hDlg, ID_BS_SET), FALSE) ;
           EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
           SendDlgItemMessage(hDlg,IDC_LIST6, LB_DELETESTRING,0,0);
           EnableWindow(GetDlgItem(hDlg, ID10), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID09), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID08), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID07), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID06), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID05), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID04), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID03), TRUE) ;
           EnableWindow(GetDlgItem(hDlg, ID02), TRUE) ;
           SetFocus(GetDlgItem(hDlg, ID04)) ;
           break;
           case IDOK:
            int_str_length=int_num_len;
            l_0_ong_rand(int_str_length);
            _itoa(int_str_length,str,10); //setup info
            SendDlgItemMessage(wnd,IDC_LIST8, LB_DELETESTRING,0,0);
            SendDlgItemMessage(wnd,IDC_LIST8, LB_INSERTSTRING,-1, str);
            SendDlgItemMessage(wnd,IDC_LIST7, LB_DELETESTRING,0,0);
            for (int_i=0;int_i<int_man;int_i++)
            {
            SendDlgItemMessage(wnd,IDC_LIST1, LB_DELETESTRING,0,0);
            SendDlgItemMessage(wnd,IDC_LIST2, LB_DELETESTRING,0,0);
            SendDlgItemMessage(wnd,IDC_LIST3, LB_DELETESTRING,0,0);
            };
            for (int_i=0;int_i<=9;int_i++) str_input[int_i]=32;
            int_str_pos=0;
            int_man=0;
            EnableWindow(GetDlgItem(wnd, ID0), TRUE);
            EnableWindow(GetDlgItem(wnd, ID1), TRUE);
            EnableWindow(GetDlgItem(wnd, ID2), TRUE);
            EnableWindow(GetDlgItem(wnd, ID3), TRUE);
            EnableWindow(GetDlgItem(wnd, ID4), TRUE);
            EnableWindow(GetDlgItem(wnd, ID5), TRUE);
            EnableWindow(GetDlgItem(wnd, ID6), TRUE);
            EnableWindow(GetDlgItem(wnd, ID7), TRUE);
            EnableWindow(GetDlgItem(wnd, ID8), TRUE);
            EnableWindow(GetDlgItem(wnd, ID9), TRUE);
            EndDialog(hDlg, TRUE);
            DeleteObject (hfontDlg);
            DeleteObject (hFinePrint);
            return (TRUE);
            break;
           case IDM_EXIT:
            DestroyWindow (hDlg);
            break;
         }
         break;
         case WM_DISPLAYCHANGE: // Only comes through on plug'n'play systems
      {
         SIZE  szScreen;
         DWORD dwBitsPerPixel = (DWORD)wParam;
         szScreen.cx = LOWORD(lParam);
         szScreen.cy = HIWORD(lParam);
         MessageBox (GetFocus(), GetStringRes(IDS_DISPLAYCHANGED),
                     szAppName, 0);
      }
      break;
      case WM_PAINT:
         hdc = BeginPaint (hDlg, &ps);
         EndPaint (hDlg, &ps);
         break;
   }
    return FALSE;
}
//--------------------------------------------------------------------
// Calculate random number ( the best!, the fast!)
//--------------------------------------------------------------------
long l_0_ong_rand(int int_num)
{
long l_nu;
int i_sum,j_sum,b_ind;
for (int_i=0;int_i<=9;int_i++) str_comp_num[int_i]=32;
i_sum=0;
while (i_sum<int_num)
 {
 l_nu=rand();
 l_nu%= 10;
 l_nu=l_nu+48;
 j_sum=0;
 b_ind=1;
  while (j_sum<i_sum)
  {
  j_sum++;
  if (str_comp_num[j_sum-1]==(char)l_nu)
   {
   b_ind=0;
   break;
   };
  };
  if (b_ind==1)
   {
   str_comp_num[i_sum]=(char)l_nu;
   i_sum++;
   };
 };
return TRUE;
}
//--------------------------------------------------------------------
// Show computer task
//--------------------------------------------------------------------
LRESULT CALLBACK SPY(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{   PAINTSTRUCT ps;
    HDC hdc;
   static  HFONT hfontDlg;   // Font for dialog text
   static  HFONT hFinePrint; // Font for 'fine print' in dialog
   int     i;
   char    szResult[256];
   SendDlgItemMessage(hDlg,IDC_LIST5, LB_INSERTSTRING,-1, str_comp_num);
   switch (message) {
        case WM_INITDIALOG:
         ShowWindow (hDlg, SW_HIDE);
            hfontDlg = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                  VARIABLE_PITCH | FF_SWISS, "");
            hFinePrint = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                    VARIABLE_PITCH | FF_SWISS, "");
         CenterWindow (hDlg, GetWindow (hDlg, GW_OWNER));
            for (i = DLG_VERFIRST; i <= DLG_VERLAST; i++) {
               GetDlgItemText(hDlg, i, szResult, sizeof(szResult));
               SendMessage (GetDlgItem (hDlg, i), WM_SETFONT,
                  (UINT)((i==DLG_VERLAST)?hFinePrint:hfontDlg),
                  TRUE);}
            SendMessage (GetDlgItem (hDlg, IDC_LABEL), WM_SETFONT,
            (WPARAM)hfontDlg,(LPARAM)TRUE);
           ShowWindow (hDlg, SW_SHOW);
         return (TRUE);
          case WM_COMMAND:
           switch (LOWORD(wParam)){
           case IDCANCEL:
            EndDialog(hDlg, TRUE);
            DeleteObject (hfontDlg);
            DeleteObject (hFinePrint);
            return (TRUE);
            break;
           case IDM_EXIT:
            DestroyWindow (hDlg);
            break;
         }
         break;
         case WM_DISPLAYCHANGE: // Only comes through on plug'n'play systems
      {
         SIZE  szScreen;
         DWORD dwBitsPerPixel = (DWORD)wParam;
         szScreen.cx = LOWORD(lParam);
         szScreen.cy = HIWORD(lParam);
         MessageBox (GetFocus(), GetStringRes(IDS_DISPLAYCHANGED),
                     szAppName, 0);
      }
      break;
      case WM_PAINT:
         hdc = BeginPaint (hDlg, &ps);
         EndPaint (hDlg, &ps);
         break;
   }
    return FALSE;
}
//--------------------------------------------------------------------
// You - hero
//--------------------------------------------------------------------
LRESULT CALLBACK WINNER(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{   PAINTSTRUCT ps;
    HDC hdc;
   static  HFONT hfontDlg;   // Font for dialog text
   static  HFONT hFinePrint; // Font for 'fine print' in dialog
   int     i;
   char    szResult[256];
   char str1[10];
   _ltoa(int_man,str1,10);
   SendDlgItemMessage(hDlg,IDC_LIST4, LB_INSERTSTRING,-1, str1);
   switch (message) {
        case WM_INITDIALOG:
         ShowWindow (hDlg, SW_HIDE);
            hfontDlg = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                  VARIABLE_PITCH | FF_SWISS, "");
            hFinePrint = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                    VARIABLE_PITCH | FF_SWISS, "");
         CenterWindow (hDlg, GetWindow (hDlg, GW_OWNER));
            for (i = DLG_VERFIRST; i <= DLG_VERLAST; i++) {
               GetDlgItemText(hDlg, i, szResult, sizeof(szResult));
               SendMessage (GetDlgItem (hDlg, i), WM_SETFONT,
                  (UINT)((i==DLG_VERLAST)?hFinePrint:hfontDlg),
                  TRUE);}
            SendMessage (GetDlgItem (hDlg, IDC_LABEL), WM_SETFONT,
            (WPARAM)hfontDlg,(LPARAM)TRUE);
           ShowWindow (hDlg, SW_SHOW);
         return (TRUE);
          case WM_COMMAND:
           switch (LOWORD(wParam)){
           case IDOK:
            EndDialog(hDlg, TRUE);
            DeleteObject (hfontDlg);
            DeleteObject (hFinePrint);
            return (TRUE);
            break;
           case IDM_EXIT:
            DestroyWindow (hDlg);
            break;
         }
         break;
         case WM_DISPLAYCHANGE: // Only comes through on plug'n'play systems
      {
         SIZE  szScreen;
         DWORD dwBitsPerPixel = (DWORD)wParam;
         szScreen.cx = LOWORD(lParam);
         szScreen.cy = HIWORD(lParam);
         MessageBox (GetFocus(), GetStringRes(IDS_DISPLAYCHANGED),
                     szAppName, 0);
      }
      break;
      case WM_PAINT:
         hdc = BeginPaint (hDlg, &ps);
         EndPaint (hDlg, &ps);
         break;
   }
    return FALSE;
}
//--------------------------------------------------------------------
//   FUNCTION: CenterWindow(HWND, HWND)
//--------------------------------------------------------------------
BOOL CenterWindow (HWND hwndChild, HWND hwndParent)
{
   RECT    rChild, rParent, rWorkArea;
   int     wChild, hChild, wParent, hParent;
   int     xNew, yNew;
   BOOL  bResult;
   GetWindowRect (hwndChild, &rChild);
   wChild = rChild.right - rChild.left;
   hChild = rChild.bottom - rChild.top;
   GetWindowRect (hwndParent, &rParent);
   wParent = rParent.right - rParent.left;
   hParent = rParent.bottom - rParent.top;
   bResult = SystemParametersInfo(
      SPI_GETWORKAREA,  // system parameter to query or set
      sizeof(RECT),
      &rWorkArea,
      0);
   if (!bResult) {
      rWorkArea.left = rWorkArea.top = 0;
      rWorkArea.right = GetSystemMetrics(SM_CXSCREEN);
      rWorkArea.bottom = GetSystemMetrics(SM_CYSCREEN);
   }
   xNew = rParent.left + ((wParent - wChild) /2);
   if (xNew < rWorkArea.left) {
      xNew = rWorkArea.left;
   } else if ((xNew+wChild) > rWorkArea.right) {
      xNew = rWorkArea.right - wChild;
   }
   yNew = rParent.top  + ((hParent - hChild) /2);
   if (yNew < rWorkArea.top) {
      yNew = rWorkArea.top;
   } else if ((yNew+hChild) > rWorkArea.bottom) {
      yNew = rWorkArea.bottom - hChild;
   }
   return SetWindowPos (hwndChild, NULL, xNew, yNew, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}
//---------------------------------------------------------------------------
// FUNCTION:    GetStringRes (int id INPUT ONLY)
//---------------------------------------------------------------------------
LPTSTR   GetStringRes (int id)
{
  static TCHAR buffer[MAX_PATH];
  buffer[0]=0;
  LoadString (GetModuleHandle (NULL), id, buffer, MAX_PATH);
  return buffer;
}
